package FunctionLayer.misc;

import edu.stanford.nlp.ling.HasWord;
import edu.stanford.nlp.ling.IndexedWord;
import edu.stanford.nlp.ling.TaggedWord;
import edu.stanford.nlp.ling.Word;
import edu.stanford.nlp.parser.lexparser.LexicalizedParser;
import edu.stanford.nlp.process.DocumentPreprocessor;
import edu.stanford.nlp.process.Tokenizer;
import edu.stanford.nlp.trees.GrammaticalStructure;
import edu.stanford.nlp.trees.GrammaticalStructureFactory;
import edu.stanford.nlp.trees.Tree;
import edu.stanford.nlp.trees.TreebankLanguagePack;
import edu.stanford.nlp.trees.TypedDependency;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author install1
 */
public class SentimentAnalyzerTest {

    public static SentimentAnalyzerTest instance = new SentimentAnalyzerTest();
    public static String grammar = "edu/stanford/nlp/models/lexparser/englishPCFG.ser.gz";
    public static String[] options = {"-maxLength", "80", "-retainTmpSubcategories"};

    public static LexicalizedParser initiateLexicalizedParser() {
        LexicalizedParser lp = LexicalizedParser.loadModel(grammar, options);
        return lp;
    }

    public static TreebankLanguagePack initiateTreebankLanguagePack(LexicalizedParser lp) {
        TreebankLanguagePack tlp = lp.getOp().langpack();
        return tlp;
    }

    public double sentimentanalyzing(String str, String str1, double sreturn, LexicalizedParser lp, TreebankLanguagePack tlp) {
        Iterable<List<? extends HasWord>> sentences;
        Tokenizer<? extends HasWord> toke
                = tlp.getTokenizerFactory().getTokenizer(new StringReader(str));
        List<? extends HasWord> sentence = toke.tokenize();
        String[] sent3 = {str1};
        String[] tag3 = {"PRP", "MD", "VB", "PRP", "."}; // Parser gets second "can" wrong without help
        List<TaggedWord> sentence2 = new ArrayList<>();
        for (int i = 0; i < sent3.length; i++) {
            sentence2.add(new TaggedWord(sent3[i], tag3[i]));
        }
        //parse.pennPrint();
        List<List<? extends HasWord>> tmp
                = new ArrayList<>();
        tmp.add(sentence2);
        tmp.add(sentence);
        sentences = tmp;
        for (List<? extends HasWord> sentence1 : sentences) {
            Tree parse1 = lp.parse(sentence1);
            GrammaticalStructureFactory gsf = tlp.grammaticalStructureFactory();
            GrammaticalStructure gs = gsf.newGrammaticalStructure(parse1);
            double score = parse1.score();
            if (score > sreturn) {
                //System.out.println("\n score : " + score + "\n");
                sreturn = score;
            }
        }
        return sreturn;
    }
}
