/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Presentation;

import FunctionLayer.ErrorMessageDisplay;
import java.util.HashMap;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author install1
 */
abstract class Command {

    private static HashMap<String, Command> commands;

    private static void initCommands() {
        commands = new HashMap();
        commands.put("SessionAttributeHandler", new SessionAttributeHandler());
        commands.put("mapfnfo", new MapInfo());
        commands.put("playerinfo", new PlayerInfo());
        commands.put("adminLogin", new AdminLogin());
        commands.put("Authenticatelogin", new Authenticatelogin());
        commands.put("DeleteEntry", new DeleteIndex());
        commands.put("CreateAdmin", new CreateAdmin());
        //add methods here for the controller
    }

    static Command from(HttpServletRequest request) throws ErrorMessageDisplay {
        String commandName = request.getParameter("command");
        if (commands == null) {
            initCommands();
        }
        return commands.getOrDefault(commandName, new SessionAttributeHandler());
    }

    abstract String execute(HttpServletRequest request, HttpServletResponse response)
            throws ErrorMessageDisplay;
}
